## reposurgeon 3.45

=== Makefile ===
#
# makefile for reposurgeon
#
GOPATH=$(shell pwd)

INSTALL=install
XMLTO=xmlto
XMLTOOPTS=-m docbook-extra.xml
ASCIIDOC=asciidoc
PYLINT=pylint
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

PYVERSION=2.7
pyinclude?=$(shell pkg-config --cflags python-$(PYVERSION) || echo "-I/usr/include/python$(PYVERSION)")
pylib?=$(shell pkg-config --libs python-$(PYVERSION) || echo "-lpython$(PYVERSION)")

VERS=$(shell sed <reposurgeon -n -e '/version=\"\(.*\)\"/s//\1/p')
SOURCES += docbook-extra.xml nofooter.conf
SOURCES += \
	reposurgeon reposurgeon.xml \
	repotool repotool.xml \
	src/*/*.go \
	repomapper.xml repocutter.xml \
	reporting-bugs.adoc features.adoc dvcs-migration-guide.adoc \
	reposurgeon-mode.el
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
SOURCES += Dockerfile ci/prepare.sh ci/Makefile ci/requirements.txt
DOCS = README.adoc NEWS TODO

.PHONY: all install clean uninstall version pylint check zip release refresh \
    docker-build docker-check docker-check-noscm

BINARIES = reposurgeon repotool repomapper repocutter
MANPAGES = reposurgeon.1 repotool.1 repomapper.1 repocutter.1
HTMLFILES = $(MANPAGES:.1=.html) \
            dvcs-migration-guide.html features.html reporting-bugs.html
SHARED    = $(DOCS) reposurgeon-git-aliases $(HTMLFILES)

all:  $(MANPAGES) $(HTMLFILES)
	GOPATH=$(GOPATH) go build repocutter
	GOPATH=$(GOPATH) go build repomapper

%.1: %.xml
	$(XMLTO) $(XMLTOOPTS) man $<

%.html: %.xml
	$(XMLTO) $(XMLTOOPTS) html-nochunks $<

dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc -f nofooter.conf
%.html: %.adoc
	$(ASCIIDOC) $(ASCIIDOC_ARGS) $<

#
# Auxilary Go productions
#

gotest:
	GOPATH=$(GOPATH) go test

goformat:
	gofmt -w src/repocutter/
	gofmt -w src/repomapper/

golint:
	@golint src/repocutter 2>&1
	@golint src/repomapper 2>&1

#
# Installation
#

install: all
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 $(BINARIES) "$(target)/bin"
	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"

clean:
	rm -fr repocutter repomapper
	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript *.pyc

# Uninstallation
INSTALLED_BINARIES := $(BINARIES:%="$(target)/bin/%")
INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")

uninstall:
	rm -f $(INSTALLED_BINARIES)
	rm -f $(INSTALLED_MANPAGES)
	rm -f $(INSTALLED_SHARED)
	rmdir "$(target)/share/doc/reposurgeon"

version:
	@echo $(VERS)

#
# Code validation
#

COMMON_PYLINT = --rcfile=/dev/null --reports=n \
	--msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
	--dummy-variables-rgx='^_'
PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C0411,C0412,C0413,C1001,C1801,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,R1705,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0633,W0640,W0511,W0611,E0611,E1101,E1103,E1124,E1133,I0011,F0401"
pylint:
	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS1) reposurgeon

check:
	make all; cd test; $(MAKE) --quiet check

portcheck:
	cd test; $(MAKE) --quiet portcheck

#
# Continuous integration.  More specifics are in the ci/ directory
#

docker-build: $(SOURCES)
	docker build -t reposurgeon .

docker-check: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon make check

docker-check-only-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-only-$(*) && make check"

docker-check-no-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-no-$(*) && make check"

# Test that support for each VCS stands on its own and test without legacy
# VCS installed
docker-check-noscm: docker-check-only-bzr docker-check-only-cvs \
    docker-check-only-git docker-check-only-mercurial \
    docker-check-only-subversion docker-check-no-cvs 
# Due to many tests depending on git, docker-check-only-mercurial is a very poor
# test of Mercurial

#
# Release shipping.
#

reposurgeon-$(VERS).tar.xz: $(SOURCES) $(DOCS)
	tar --transform='s:^:reposurgeon-$(VERS)/:' --show-transformed-names -cJf reposurgeon-$(VERS).tar.xz $(SOURCES) $(DOCS) test

dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repocutter.1 repotool.1 repomapper.1

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

zip: $(SOURCES) $(DOCS)
	zip -r reposurgeon-$(VERS).zip $(SOURCES) $(DOCS)

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html dvcs-migration-guide.html features.html
	shipper version=$(VERS) | sh -e -x

refresh: reposurgeon.html repocutter.html repomapper.html reporting-bugs.html features.html
	shipper -N -w version=$(VERS) | sh -e -x

=== ci/Makefile ===
#
# makefile for reposurgeon continuous integration
#

VERS=$(shell sed <reposurgeon -n -e '/version=\(.*\)/s//\1/p')

.PHONY: 

install-hglib:
	pip install 'python-hglib>=1.9'

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# By setting the REPOSURGEON environment variable and using -e
# a different implementation can be plugged in to the tests.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(realpath ..):$(realpath .):${PATH}
REPOSURGEON := reposurgeon 
REPOCUTTER := repocutter 
REPOTOOL := repotool 
REPOMAPPER := repomapper

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

# Without this, under CentOS Python may emit invisible ANSI strings
# that confuse diff
TERM := dumb

default: check

# Speed check - test under the default in the hashbang line
check:
	@if command -v pylint >/dev/null 2>&1; then echo "=== Running pylint" && (cd ..; make -e --quiet pylint); else echo "pylint missing; skipping tests"; fi
	@if { ./setpypy pypy || ./setpypy python; } 2>/dev/null; then echo "=== Running built-in tests" && $(REPOSURGEON) "runtests"; else echo "pypy/python missing; skipping built-in tests"; fi
	@if { ./setpypy pypy || ./setpypy python; } 2>/dev/null; then time make -e --quiet python; else echo "pypy/python missing; skipping tests"; fi
	@./setpypy pypy 2>/dev/null || :
	@time make nonpython
	@echo "=== No diff output is good news."

# Portability check - tests all dialects
portcheck: check
	@if ./setpypy python2; then time make -e --quiet python; else echo "python2 missing; skipping tests"; fi
	@if ./setpypy python3; then time make -e --quiet python; else echo "python3 missing; skipping tests"; fi
	@./setpypy pypy 2>/dev/null || :
	@time make nonpython
	@echo "=== No diff output is good news."

python: listcheck roundtrip roundtrip-compress mailboxing fi-regress coalesce \
		git-regress git-regress-branches git-regress-merges \
		git-regress-tags hg-extractor svnload-regress \
		liftcheck-regress legacy-regress svndump-regress \
		svncheck-regress

nonpython: repomapper-regress repotool-regress repocutter-regress

hg-extractor: hg-regress hg-regress-branches hg-regress-merges \
		hg-regress-tags hg-regress-patho

.SUFFIXES: .svn .chk .fi .map

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "read <$<" "legacy write -" >$@

buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
	svndump-buildregress repomapper-buildregress \
	repotool-buildregress repocutter-buildregress hg-buildregress-branches \
	hg-buildregress-patho svncheck-buildregress

clean:
	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description"; fi; \
	done

# Test that all stream files round-trip properly
roundtrip:
	@echo "=== Testing stream-file round-tripping:" 
	@for file in *.fi; do \
	    echo "  $${file}"; \
	    $(REPOSURGEON) "read -;write -" <$$file >/tmp/rs$$$$ || exit 1; \
	    [ -s /tmp/rs$$$$ ] && diff --text -u $${file} /tmp/rs$$$$ \
		|| exit 1; \
	    rm -f /tmp/rs$$$$ || exit 1; \
	done

# Test that all stream files round-trip properly with compression
roundtrip-compress:
	@echo "=== Testing stream-file round-tripping with compression:" 
	@for file in *.fi; do \
	    echo "  $${file}"; \
	    $(REPOSURGEON) "set compressblobs" "read -;write -" \
		<$$file >/tmp/rs$$$$ || exit 1; \
	    [ -s /tmp/rs$$$$ ] && diff --text -u $${file} /tmp/rs$$$$ \
		|| exit 1; \
	    rm -f /tmp/rs$$$$ || exit 1; \
	done

# Test that dumping metadata to mailbox form and updating from the mailbox
# is idempotent if you make no changes to the mailbox.
mailboxing:
	@echo "=== Testing mailbox-out/mailbox-in roundtripping:"
	@for file in *.fi; do \
	    echo "  $${file}";\
	    $(REPOSURGEON) "read <$${file}" "edit echo>/dev/null" "write -" \
		>/tmp/regress$$$$ || exit 1; \
	    [ -s /tmp/regress$$$$ ] && diff --text -u $${file} /tmp/regress$$$$ \
		|| exit 1; \
	done
	@rm -f /tmp/regress$$$$

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
TESTLOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
fi-buildregress:
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit 1; \
	done
fi-regress:
	@echo "=== Running general tests:"
	@for file in $(TESTLOADS); do \
	    $(ECHO) -n "  $${file} "; grep --text '##' $${file}.tst  || echo ' ## (no description)'; \
	    if $(REPOSURGEON) "script $${file}.tst testing123" >/tmp/regress$$$$ 2>&1; \
	    then diff --text -u $${file}.chk /tmp/regress$$$$ || exit 1; \
	    else echo "*** Nonzero return status on $${file}!"; exit 1; fi \
	done
	@rm -f /tmp/regress$$$$

# Test coalescence operation.
COALESCE=uncoalesced
buildcoalesce:
	@for file in $(COALESCE); do \
	    echo "Rebuilding coalescence regression test using $${file}.fi"; \
	    $(REPOSURGEON) "read <$${file}.fi; coalesce; write -" \
		>$${file}.chk || exit 1; \
	done
	@rm -f /tmp/regress$$$$
coalesce:
	@echo "=== Coalescence regression test:"
	@for file in $(COALESCE); do \
	    echo "  $${file}.fi"; \
	    $(REPOSURGEON) "read <$${file}.fi; coalesce; write -" \
		>/tmp/regress$$$$ || exit 1; \
	    [ -s /tmp/regress$$$$ ] && diff --text -u $${file}.chk /tmp/regress$$$$ \
		|| exit 1; \
	done
	@rm -f /tmp/regress$$$$

# Test the git extractor
GITLOADS = bs
git-regress:
	@echo "=== Testing git-extractor:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with multiple git branches
GITBRANCHES = be bb
git-regress-branches:
	@echo "=== Testing git-extractor with multiple git branches:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITBRANCHES); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with merges
GITMERGES = be2 be3 be4 be5 be6
git-regress-merges:
	@echo "=== Testing git-extractor with merges:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITMERGES); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with tags
GITTAGS = bt bt2
git-regress-tags:
	@echo "=== Testing git-extractor with tags:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITTAGS); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor
HGLOADS = testrepo2
hg-regress:
	@echo "=== Testing hg-extractor:"
	@if command -v hg >/dev/null 2>&1 && command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(HGLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./hg-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg or git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with multiple hg branches
# NOTE: the bb-alt test demonstrates an hg repo with coloring that git cannot reproduce
HGBRANCHES = be be2 be3 bb-alt be-bookmarks
hg-buildregress-branches:
	@for file in $(HGBRANCHES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-branches:
	@echo "=== Testing hg-extractor with multiple hg branches:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGBRANCHES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with merges
HGMERGES = be2 be3 be4 be5 be6
hg-buildregress-merges:
	@for file in $(HGMERGES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-merges:
	@echo "=== Testing hg-extractor with merges:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGMERGES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with tags
HGTAGS = bt bt2
hg-buildregress-tags:
	@for file in $(HGTAGS); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-tags:
	@echo "=== Testing hg-extractor with tags:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGTAGS); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with pathological loads
HGPATHO = be-subrepo be-subrepo2
hg-buildregress-patho:
	@for file in $(HGPATHO); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test 2>/dev/null | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-patho:
	@echo "=== Testing hg-extractor with pathological loads:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGPATHO); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test 2>/dev/null) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test loading from Subversion
SVNLOADS := $(shell ls *.svn | sed '/.svn/s///')
svnload-buildregress:
	@for test in $(SVNLOADS); do \
	    if [ ! -f $${test}.tst ] ; \
	    then \
		    echo "Remaking $${test}.chk"; \
		    rm -f $${test}.chk && make --quiet $${test}.chk \
			|| exit 1; \
	    fi \
	done
svnload-regress:

=== debian/changelog ===
reposurgeon (3.45-1) unstable; urgency=medium

  * New upstream release 3.45:
     - Repaired the distribution maker to again include README.adoc, NEWS, TODO.
     - Executable bits are now correctly propagated across SVN branch copies.
     - Tests fall back to (c-)python if pypy is not available.
     - Various minor testsuite and port fixes. Tests now work on Mac OS X.
     - repocutter ported to Go for 40x speedup (more on large repos).
     - repomapper has been ported to Go; repodiffer has been retired.
  * Remove repodiffer which has been retired upstream
  * Bump Standards-Version to 4.2.1 (no change)
  * Change Architecture from "all" back to "any"
    because some tools have been rewritten in Go.
  * Add "Build-Depends: golang-any" for building repocutter and repomapper
    which have been rewritten in Go.
  * Build with '-{gc,asm}flags all=-trimpath=' for reproducibility.
    Copied from dh-golang (1.38).
    See also https://github.com/restic/restic/issues/2061
    and https://gitlab.com/esr/reposurgeon/merge_requests/181

 -- Anthony Fok <foka@debian.org>  Fri, 21 Dec 2018 17:23:02 -0700

=== debian/control ===
Source: reposurgeon
Maintainer: Anthony Fok <foka@debian.org>
Section: vcs
Priority: optional
Build-Depends: debhelper (>= 11),
               dh-python,
               golang-any,
               pypy,
               python,
               pkg-config,
               pylint,
               time,
               tzdata,
               xmlto,
               asciidoc-base,
               cvs,
               git,
               mercurial,
               subversion
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
Homepage: http://www.catb.org/esr/reposurgeon/

Package: reposurgeon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${pypy:Depends},
         tzdata
Recommends: git,
            cvs-fast-export
Suggests: bzr-fastimport,
          hg-fast-export,
          subversion,
          darcs,
          fossil
Description: Tool for editing version-control repository history
 `reposurgeon` enables risky operations that version-control systems
 don't want to let you do, such as (a) editing past comments and metadata,
 (b) excising commits, (c) coalescing commits, and (d) removing files and
 subtrees from repo history. The original motivation for `reposurgeon`
 was to clean up artifacts created by repository conversions.
 .
 `reposurgeon` is also useful for scripting very high-quality
 conversions from Subversion.  It is better than `git-svn` at tag
 lifting, automatically cleaning up `cvs2svn` conversion artifacts,
 dealing with nonstandard repository layouts, recognizing branch
 merges, handling mixed-branch commits, and generally at coping with
 Subversion's many odd corner cases.  Normally Subversion repos should
 be analyzed at a rate of upwards of ten thousand commits per minute,
 though that rate can fall significantly on extremely large
 repositories.
 .
 Another auxiliary program, `repotool`, performs various useful
 operations such as checkouts and tag listing in a VCS-independent
 manner.  Yet another, `repomapper`, assists in automatically preparing
 contributor maps of CVS and SVN repositories.
 .
 The `repocutter` program is available for some specialized operations on
 Subversion dumpfiles; it may be useful in extracting portions of
 particularly gnarly Subversion repositories for conversion witth
 reposurgeon.
 .
 This distribution supports a generic conversion workflow using these
 tools, and includes the DVCS Migration Guide that describes how to use it.

=== debian/rules ===
#!/usr/bin/make -f

export PYLINTHOME := $(CURDIR)/.pylint.d

%:
	dh $@ --with pypy

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

## reposurgeon 4.3+git20200214.8d048e1

=== Makefile ===
#
# makefile for reposurgeon
#
INSTALL=install
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

VERS=$(shell sed <surgeon/reposurgeon.go -n -e '/const *version *= *\"\(.*\)\"/s//\1/p')
SOURCES = \
	reposurgeon.adoc \
	repotool repotool.adoc \
	cutter/repocutter.go \
	mapper/repomapper.go \
	surgeon/reposurgeon.go \
	surgeon/reposurgeon_test.go \
        surgeon/baton.go \
        surgeon/extractor.go \
        surgeon/hgclient.go \
        surgeon/reposurgeon.go \
        surgeon/reposurgeon_test.go \
        surgeon/selection.go \
	repomapper.adoc repocutter.adoc \
	reporting-bugs.adoc features.adoc dvcs-migration-guide.adoc \
	reposurgeon-mode.el \
        go.mod
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
SOURCES += Dockerfile ci/prepare.sh .gitlab-ci.yml
DOCS = README.adoc INSTALL.adoc NEWS AUTHORS COPYING

STOPOUT=1

.PHONY: all install clean uninstall version check release refresh \
    docker-build docker-check docker-check-noscm \
    vet test fmt lint

BINARIES = reposurgeon repotool repomapper repocutter
MANPAGES = reposurgeon.1 repotool.1 repomapper.1 repocutter.1
HTMLFILES = $(MANPAGES:.1=.html) \
            dvcs-migration-guide.html features.html reporting-bugs.html
SHARED    = $(DOCS) reposurgeon-git-aliases $(HTMLFILES)

# The following would produce reproducible builds, but it breaks Gitlab CI.
#GOFLAGS=-gcflags 'all=-N -l -trimpath $(GOPATH)/src' -asmflags 'all=-trimpath $(GOPATH)/src'

GOFLAGS=-gcflags '-N -l'
build:  $(MANPAGES) $(HTMLFILES)
	go build $(GOFLAGS) -o repocutter ./cutter
	go build $(GOFLAGS) -o repomapper ./mapper
	go build $(GOFLAGS) -o reposurgeon ./surgeon

# Requires asciidoctor and xsltproc/docbook stylesheets.
# Note: to suppress the footers with timestamps being generated in HTML,
# we use "-a nofooter".
# To debug asciidoc problems, you may need to run "xmllint" --nonet --noout --valid"
# on the intermediate XML.
.SUFFIXES: .html .adoc .1

.adoc.1:
	asciidoctor -a nofooter -b manpage $<
.adoc.html:
	asciidoctor -a webfonts! $<

#
# Auxilary Go tooling productions
#

get:
	go get -u ./...	# go get -u=patch for patch releases

test:
	go test $(TESTOPTS) ./surgeon

lint:
	golint ./... | ./lintfilter 2>&1

fmt:
	gofmt -w .

#
# Installation
#

install: all
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 $(BINARIES) "$(target)/bin"
	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"

clean:
	rm -fr reposurgeon repocutter repomapper
	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript *.pyc

# Uninstallation
INSTALLED_BINARIES := $(BINARIES:%="$(target)/bin/%")
INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")

uninstall:
	rm -f $(INSTALLED_BINARIES)
	rm -f $(INSTALLED_MANPAGES)
	rm -f $(INSTALLED_SHARED)
	rmdir "$(target)/share/doc/reposurgeon"

version:
	@echo $(VERS)

#
# Code validation
#

check: lint build test
	cd test; $(MAKE) --quiet fullcheck

#
# Continuous integration.  More specifics are in the ci/ directory
#

docker-build: $(SOURCES)
	docker build -t reposurgeon .

docker-check: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon make check

docker-check-only-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-only-$(*) && make check"

docker-check-no-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-no-$(*) && make check"

# Test that support for each VCS stands on its own and test without legacy
# VCS installed
docker-check-noscm: docker-check-only-bzr docker-check-only-cvs \
    docker-check-only-git docker-check-only-mercurial \
    docker-check-only-subversion docker-check-no-cvs 
# Due to many tests depending on git, docker-check-only-mercurial is a very poor
# test of Mercurial

#
# Release shipping.
#

reposurgeon-$(VERS).tar.xz: $(SOURCES) $(DOCS)
	tar --transform='s:^:reposurgeon-$(VERS)/:' --show-transformed-names -cJf reposurgeon-$(VERS).tar.xz $(SOURCES) $(DOCS) test

dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repocutter.1 repotool.1 repomapper.1

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html dvcs-migration-guide.html features.html
	shipper version=$(VERS) | sh -e -x

refresh: reposurgeon.html repocutter.html repomapper.html reporting-bugs.html features.html
	shipper -N -w version=$(VERS) | sh -e -x

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# By setting the REPOSURGEON environment variable and using -e
# a different implementation can be plugged in to the tests.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(realpath ..):$(realpath .):${PATH}
REPOSURGEON := reposurgeon 
REPOCUTTER := repocutter 
REPOTOOL := repotool
REPOMAPPER := repomapper

# Force the timezone in case CI has a different idea
export TZ=UTC

# Setting this to 0 allows tests to continue on error.
STOPOUT=1

# Setting this to 1 suppresses diffs in favor of a FAIL tag
QUIET=0

# Force pure serial execution when rebuilding check files.  Slower,
# but makes them deterministic and may help smoke out bugs in
# concurrent code.
BUILDOPT="'set serial'"

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

default: fastcheck

# Define test groups
BASIC = listcheck roundtrip roundtrip-compress messagebox fi-regress
SUBVERSION = svnload-regress liftcheck-regress legacy-regress svncheck-regress
FULLSUBVERSION = $(SUBVERSION) liftcheck-fullregress
GIT_EXTRACTOR = git-regress git-regress-branches git-regress-merges git-regress-tags
HG_EXTRACTOR = hg-regress hg-regress-branches hg-regress-merges hg-regress-tags \
	hg-regress-patho
AUXTOOLS = repocutter-regress repomapper-regress repotool-regress

# See https://stackoverflow.com/questions/6481005/how-to-obtain-the-number-of-cpus-cores-in-linux-from-the-command-line
CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)

# Exploit make parallelism
PARALLEL_MAKE=make --output-sync --no-print-directory -j $(CONCURRENT_JOBS)

# This series can change depending on the current development focus
fastcheck: clean disclose $(BASIC) $(SUBVERSION)
	@echo "=== No diff output is good news ==="

# This should always be a full test
fullcheck: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS)
	@echo "=== No diff output is good news ==="

disclose:
	@echo "Running with $(CONCURRENT_JOBS) threads."

# FIXME: is log -all really correct when regenerating the map checks?

.SUFFIXES: .svn .chk .fi .map

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "log -all" "read <$<" "legacy write -" >$@

buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
	repomapper-buildregress repotool-buildregress hg-buildregress-branches \
	svncheck-buildregress repocutter-buildregress repomapper-buildregress \
	repotool-buildregress

clean:
	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~

options:
	@echo "REPOSURGEON is '$(REPOSURGEON)'"
	@echo "TESTOPT is '$(TESTOPT)'"

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description" >&2; exit $(STOPOUT); fi;  \
	done

# Test that all stream files round-trip properly
RULES_ROUNDTRIP=$(patsubst %,roundtrip-%,$(wildcard *.fi))
roundtrip:
	@echo "=== Testing stream-file round-tripping:"
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP)

$(RULES_ROUNDTRIP): roundtrip-%: %
	@echo "  $<"; \
	$(REPOSURGEON) "$(TESTOPT)" "read -;write -" <$< >/tmp/rs$$$$ || exit $(STOPOUT); \
	[ -s /tmp/rs$$$$ ] && diff --text -u $< /tmp/rs$$$$ \
		|| exit $(STOPOUT); \
	rm -f /tmp/rs$$$$ || exit $(STOPOUT)

# Test that all stream files round-trip properly with compression
RULES_ROUNDTRIP_COMPRESS=$(patsubst %,roundtrip-compress-%,$(wildcard *.fi))
roundtrip-compress:
	@echo "=== Testing stream-file round-tripping with compression:" 
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP_COMPRESS)

$(RULES_ROUNDTRIP_COMPRESS): roundtrip-compress-%: %
	@echo "  $<"; \
	$(REPOSURGEON) "$(TESTOPT)" "set compressblobs" "read -;write -" \
		<$< >/tmp/rs$$$$ || exit $(STOPOUT); \
	[ -s /tmp/rs$$$$ ] && diff --text -u $< /tmp/rs$$$$ \
		|| exit $(STOPOUT); \
	rm -f /tmp/rs$$$$ || exit $(STOPOUT)

# Test that dumping metadata to msgbox form and updating from the message-box
# is idempotent if you make no changes to the message-box.
RULES_MESSAGE_BOX=$(patsubst %,messagebox-%,$(wildcard *.fi))
messagebox:
	@echo "=== Testing msgout/msgin roundtripping:"
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP_COMPRESS)

$(RULES_MESSAGE_BOX): messagebox-%: %
	@echo "  $${file}";\
	$(REPOSURGEON) "$(TESTOPT)" "read <$<" "edit echo>/dev/null" "write -" \
	>/tmp/regress$$$$ || exit $(STOPOUT); \
	[ -s /tmp/regress$$$$ ] && diff --text -u $< /tmp/regress$$$$ \
	|| exit $(STOPOUT); \
	rm -f /tmp/regress$$$$

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
TESTLOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
fi-buildregress: multigen.svn
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) "$(BUILDOPT)" "$(TESTOPT)" "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit $(STOPOUT); \
	done

fi-regress: multigen.svn
	@echo "=== Running general tests:"
	@$(PARALLEL_MAKE) $(TESTLOADS:%=fi-regress-%)

# A generated test load
multigen.svn: multigen.sh
	sh multigen.sh -d >multigen.svn
	sh singlelift -b multigen

$(TESTLOADS:%=fi-regress-%): fi-regress-%: %.tst
	@file=$(<:.tst=); \
	( $(ECHO) -n "  $${file} "; grep --text '##' $${file}.tst  || echo ' ## (no description)' ) | sed -e '/ ##/s//:/' ; \
	    $(REPOSURGEON) "$(TESTOPT)" "script $${file}.tst testing123" >/tmp/regress$$$$ 2>&1 \
		|| (echo "*** Nonzero return status on $${file}!"; exit $(STOPOUT) ); \
	    diff --text -u $${file}.chk /tmp/regress$$$$ >/tmp/diff$$$$; \
	    case $$? in \
	    0) ;; \
	    1) if [ $(QUIET) = 1 ]; then echo FAILED; else cat /tmp/diff$$$$; fi; if [ $(STOPOUT) = 1 ]; then exit 1; fi;; \
	    *) echo "*** diff had trouble, status $$?"; exit $(STOPOUT);; \
	    esac ; \
	rm -f /tmp/regress$$$$ /tmp/diff$$$$

# Test the git extractor
GITLOADS = bs
git-regress:
	@echo "=== Testing git-extractor:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITLOADS:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with multiple git branches
GITBRANCHES = be bb
git-regress-branches:
	@echo "=== Testing git-extractor with multiple git branches:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITBRANCHES:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with merges
GITMERGES = be2 be3 be4 be5 be6
git-regress-merges:
	@echo "=== Testing git-extractor with merges:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITMERGES:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with tags
GITTAGS = bt bt2
git-regress-tags:
	@echo "=== Testing git-extractor with tags:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITTAGS:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

RULES_GIT_REGRESS=$(patsubst %,git-regress-test-%, \
			$(GITLOADS) $(GITBRANCHES) $(GITTAGS) $(GITMERGES))

$(RULES_GIT_REGRESS): git-regress-test-%: %.fi
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	test=$(<:.fi=); \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit $(STOPOUT); \
		else echo "*** Nonzero return status on $${test}!"; exit $(STOPOUT); fi; \
	rm -f /tmp/regress$$$$


# Test the hg extractor
HGLOADS = testrepo2
hg-regress:
	@echo "=== Testing hg-extractor:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 && command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(HGLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./hg-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit $(STOPOUT); \
		else echo "*** Nonzero return status on $${test}!"; exit $(STOPOUT); fi \
	    done; \
	else echo "    Skipped, hg or git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with multiple hg branches
# NOTE: the bb-alt test demonstrates an hg repo with coloring that git cannot reproduce
HGBRANCHES = be be2 be3 bb-alt be-bookmarks
hg-buildregress-branches:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT="$(BUILDOPT)"; export BUILDOPT;\
	for file in $(HGBRANCHES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-branches:
	@echo "=== Testing hg-extractor with multiple hg branches:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGBRANCHES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit $(STOPOUT); \
		else echo "*** Nonzero return status on $${test}!"; exit $(STOPOUT); fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with merges
HGMERGES = be2 be3 be4 be5 be6
hg-buildregress-merges:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	for file in $(HGMERGES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-merges:
	@echo "=== Testing hg-extractor with merges:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGMERGES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit $(STOPOUT); \
		else echo "*** Nonzero return status on $${test}!"; exit $(STOPOUT); fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with tags
HGTAGS = bt bt2
hg-buildregress-tags:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT="$(BUILDOPT)"; export BUILDOPT;\
	for file in $(HGTAGS); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-tags:
	@echo "=== Testing hg-extractor with tags:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGTAGS); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit $(STOPOUT); \
		else echo "*** Nonzero return status on $${test}!"; exit $(STOPOUT); fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with pathological loads
HGPATHO = be-subrepo be-subrepo2
hg-buildregress-patho:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT="$(BUILDOPT)"; export BUILDOPT;\
	for file in $(HGPATHO); do \
	    echo "Remaking $${file}.fi"; \

=== debian/changelog ===
reposurgeon (4.3+git20200214.8d048e1-1ubuntu0.2) focal-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Fri, 20 Jan 2023 17:37:29 +0100

reposurgeon (4.3+git20200214.8d048e1-1ubuntu0.1) focal-security; urgency=medium

  * No-change rebuild due to golang-1.13 update

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 11 Oct 2022 02:38:51 +0200

reposurgeon (4.3+git20200214.8d048e1-1) unstable; urgency=medium

  * New upstream version 4.3+git20200214.8d048e1
  * debian/control: Build on 64-bit architectures only, at least for now.
    See https://gitlab.com/esr/reposurgeon/issues/255#note_288045356
  * Remove 0001-asciidoctor-disable-webfonts.patch
    which has been applied upstream, see
    https://gitlab.com/esr/reposurgeon/-/merge_requests/456 and
    https://gitlab.com/esr/reposurgeon/-/commit/8d048e1

 -- Anthony Fok <foka@debian.org>  Fri, 14 Feb 2020 15:23:45 -0700

reposurgeon (4.2-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Recommend brz rather than bzr-fastimport.

  [ Anthony Fok ]
  * New upstream version 4.2
  * Apply "cme fix dpkg" fixes
    - Update debhelper dependency to "Build-Depends: debhelper-compat (= 12)"
    - Bump Standards-Version to 4.5.0 (no change)
  * Update debian/copyright with correct BSD-2-Clause text
    and with new author and copyright years
  * Remove 0001-build-with-trimpath-for-reproducibility.patch
  * Adapt Debian packaging to the new Go reposurgeon
  * Include yet-to-be-packaged dependent Go libraries
  * Disable webfonts in Asciidoctor-generated HTML files
    (Lintian warning "reposurgeon: privacy-breach-generic")

 -- Anthony Fok <foka@debian.org>  Thu, 13 Feb 2020 13:28:18 -0700

=== debian/control ===
--- 
+++ 
@@ -1,40 +1,46 @@
 Source: reposurgeon
-Maintainer: Anthony Fok <foka@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
+Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: asciidoctor,
+               cvs,
+               debhelper-compat (= 12),
+               dh-golang,
                dh-python,
+               git,
                golang-any,
-               pypy,
-               python,
-               pkg-config,
-               pylint,
+               golang-github-anmitsu-go-shlex-dev,
+               golang-github-emirpasic-gods-dev,
+               golang-golang-x-crypto-dev,
+               golang-golang-x-text-dev,
+               golint,
+               mercurial,
+               python3,
+               subversion,
                time,
-               tzdata,
-               xmlto,
-               asciidoc-base,
-               cvs,
-               git,
-               mercurial,
-               subversion
-Standards-Version: 4.2.1
+               tzdata
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
 Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
+XS-Go-Import-Path: gitlab.com/esr/reposurgeon
 
 Package: reposurgeon
-Architecture: any
-Depends: ${shlibs:Depends},
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha ia64 kfreebsd-amd64 ppc64 riscv64 sparc64
+Depends: tzdata,
          ${misc:Depends},
-         ${pypy:Depends},
-         tzdata
-Recommends: git,
-            cvs-fast-export
-Suggests: bzr-fastimport,
+         ${python3:Depends},
+         ${shlibs:Depends}
+Recommends: cvs-fast-export,
+            git
+Suggests: brz,
+          darcs,
+          fossil,
           hg-fast-export,
-          subversion,
-          darcs,
-          fossil
+          subversion
+Built-Using: ${misc:Built-Using}
 Description: Tool for editing version-control repository history
  `reposurgeon` enables risky operations that version-control systems
  don't want to let you do, such as (a) editing past comments and metadata,

=== debian/watch ===
# HTTP site (basic)
#version=4
#http://www.catb.org/~esr/reposurgeon/ \
#    reposurgeon-(\d[\d.]*)\.tar\.(?:gz|bz2|xz) debian

# direct access to the git repository (tags)
#version=4
#opts="mode=git, gitmode=full, pgpmode=none" \
#    https://gitlab.com/esr/reposurgeon.git \
#    refs/tags/([\d\.]+) debian

# direct access to the git repository (HEAD)
version=4
opts="mode=git, pgpmode=none, pretty=4.3+git%cd.%h" \
    https://gitlab.com/esr/reposurgeon.git \
    HEAD debian

## reposurgeon 4.4

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
         surgeon/reposurgeon_test.go \
         surgeon/selection.go \
 	repomapper.adoc repocutter.adoc \
-	reporting-bugs.adoc features.adoc dvcs-migration-guide.adoc \
+	reporting-bugs.adoc dvcs-migration-guide.adoc \
 	reposurgeon-mode.el \
         go.mod
 SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
@@ -37,7 +37,7 @@
 BINARIES = reposurgeon repotool repomapper repocutter
 MANPAGES = reposurgeon.1 repotool.1 repomapper.1 repocutter.1
 HTMLFILES = $(MANPAGES:.1=.html) \
-            dvcs-migration-guide.html features.html reporting-bugs.html
+            repository-editing.html dvcs-migration-guide.html reporting-bugs.html
 SHARED    = $(DOCS) reposurgeon-git-aliases $(HTMLFILES)
 
 # The following would produce reproducible builds, but it breaks Gitlab CI.
@@ -114,7 +114,7 @@
 #
 
 check: lint build test
-	cd test; $(MAKE) --quiet fullcheck
+	cd test; $(MAKE) --quiet check
 
 #
 # Continuous integration.  More specifics are in the ci/ directory
@@ -152,7 +152,7 @@
 reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
 	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5
 
-release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html dvcs-migration-guide.html features.html
+release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html repository-editing.html dvcs-migration-guide.html
 	shipper version=$(VERS) | sh -e -x
 
 refresh: reposurgeon.html repocutter.html repomapper.html reporting-bugs.html features.html

=== test/Makefile ===
--- 
+++ 
@@ -46,12 +46,8 @@
 # Exploit make parallelism
 PARALLEL_MAKE=make --output-sync --no-print-directory -j $(CONCURRENT_JOBS)
 
-# This series can change depending on the current development focus
-fastcheck: clean disclose $(BASIC) $(SUBVERSION)
-	@echo "=== No diff output is good news ==="
-
 # This should always be a full test
-fullcheck: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS)
+check: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS)
 	@echo "=== No diff output is good news ==="
 
 disclose:
@@ -312,3 +308,8 @@
 	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT="$(BUILDOPT)"; export BUILDOPT;\
 	for file in $(HGPATHO); do \
 	    echo "Remaking $${file}.fi"; \
+	    ./hg-$${file}-test 2>/dev/null | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
+		2>&1 || exit $(STOPOUT); \
+	done
+hg-regress-patho:
+	@echo "=== Testing hg-extractor with pathological loads:"

=== debian/changelog ===
reposurgeon (4.4-1) unstable; urgency=medium

  * New upstream version 4.4
  * Set debian/watch to track release tarball as before
  * Add "Rules-Requires-Root: no" to debian/control
  * Add 0001-restore-missing-files.patch to restore surgeon/svnread.go,
    repository-editing.adoc and lintfilter which are missing in the
    reposurgeon-4.4.tar.xz upstream tarball
  * Build repository-editing.html instead of features.html
    which has been merged into the former and removed.

 -- Anthony Fok <foka@debian.org>  Wed, 04 Mar 2020 05:34:35 -0700

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: reposurgeon
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
+Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
 Testsuite: autopkgtest-pkg-go
 Priority: optional
@@ -25,6 +24,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
 Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
+Rules-Requires-Root: no
 XS-Go-Import-Path: gitlab.com/esr/reposurgeon
 
 Package: reposurgeon

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := test

MANPAGES = reposurgeon.1 repotool.1 repomapper.1 repocutter.1
HTMLFILES = $(MANPAGES:.1=.html) \
            repository-editing.html dvcs-migration-guide.html reporting-bugs.html

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with golang,python3

execute_after_dh_auto_configure:
	ln -s $(CURDIR)/debian/go/src _build/src/gitlab.com/esr/reposurgeon/vendor

execute_after_dh_auto_build:
	for i in cutter mapper surgeon; do \
		cp -al _build/bin/$$i repo$$i ; \
		done
	make $(MANPAGES) $(HTMLFILES)

override_dh_auto_install:
	DH_INTERNAL_OPTIONS= dh_auto_install -- prefix=/usr

# Run "make check" for fullcheck when ready
#
#override_dh_auto_test:
#	$(subst test,check,$(shell dh_auto_test --no-act -v))

execute_after_dh_auto_clean:
	DH_INTERNAL_OPTIONS= dh_auto_clean
